unit bunixsignals;

interface

uses
  {$ifdef VER1_0}
    linux,
  {$else}
    baseunix,
    unix,
  {$endif}
  lcore,lsignal,
  sysutils;

procedure init;

implementation

uses
  bircservunit;

type
  tsigc=class(tobject)
    procedure signalhandler(sender:tobject;signal:integer);
    procedure rehashhandler(wparam:word;lparam:integer);
  end;

var
  sigc:tsigc;

procedure tsigc.signalhandler;
begin
  case signal of
    sigterm: begin
      form1.diereason := 'received signal SIGTERM';
      form1.formclose;
    end;
    sigint: begin
      form1.diereason := 'received signal SIGINT';
      form1.formclose;
    end;
  end;
end;

procedure init;
begin
  with tlsignal.create(nil) do onsignal := @sigc.signalhandler;
  starthandlesignal(sigterm);
  starthandlesignal(sigint);
  starthandlesignal(sighup);
end;

end.
